=== src/xrt/state_trackers/CMakeLists.txt ===
# Copyright 2019, Collabora, Ltd.
# SPDX-License-Identifier: BSL-1.0

add_subdirectory(gui)
add_subdirectory(oxr)
add_subdirectory(prober)
