=== debian/changelog ===
monado (0.1.0+git108.a8a4d8c3-2) unstable; urgency=medium

  * Add patches to fix build on ppc64el, s390x, powerpc
  * Rebuild to unblock migration.

 -- Ryan Pavlik <ryan@ryanpavlik.com>  Thu, 09 Apr 2020 18:03:59 -0500

monado (0.1.0+git108.a8a4d8c3-1) unstable; urgency=medium

  * Initial release (Closes: #943486)

 -- Ryan Pavlik <ryan@ryanpavlik.com>  Wed, 08 Apr 2020 10:11:01 -0500
