=== debian/tests/control ===
Tests: cli-probe, cli-test
Depends: monado-cli
Restrictions: superficial, allow-stderr
